Overview | Package | Class | Tree | Deprecated | Index | Help
| Oracle Application Development Framework Model and Business Components Java API Reference 10g Release 3 (10.1.3) B16005-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.jbo.server.java.util
Interface List

All Superinterfaces:
  Collection

All Known Implementing Classes:
  AbstractList, ArrayList

public interface List
extends Collection

An ordered Collection (also known as a sequence). The user of this interface has precise control over where in the List each element is inserted. The user can access elements by their integer index (position) in the List, and search for elements in the List.

Unlike Sets, Lists typically allow duplicate elements. More formally, Lists typically allow pairs of elements `e1` and `e2` such that `e1.equals(e2)`, and they typically allow multiple null elements if they allow null elements at all. It is not inconceivable that someone might wish to implement a List that prohibits duplicates, by throwing runtime exceptions when the user attempts to insert them, but we expect this usage to be rare.

The List interface places additional stipulations, beyond those specified in the Collection Interface, on the contracts of the iterator, add, remove, equals, and hashCode methods. Declarations for other inherited methods are also included here for convenience.

Lists provide four methods for positional (indexed) access to List elements. Lists (like Java arrays) are zero based. Note that these operations may execute in time proportional to the index value for some implementations (LinkedList, for example). Thus, iterating over the elements in a List is typically preferable to indexing through it if the caller does not know the implementation.

List provides a special Iterator, called a ListIterator, that allows element insertion and replacement, and bidirectional access in addition to the normal Iterator operations. A method is provided to obtain a List iterator that starts at a specified position in the List.

List provides four methods to search for a specified object. From a performance standpoint, these methods should be used with caution. In many implementations, they will perform costly linear searches.

List provides two methods to efficiently insert and remove multiple elements at an arbitrary point in the List.

Implemented by ArrayList, LinkedList, Vector, and returned by Arrays.toList, Collection.subList and Collections.ncopies.

Since:
  JDK1.2
See Also:
  `Collection`, `Set`, `ArrayList`, `LinkedList`, `Vector`, `Collections.nCopies(int, Object)`, `AbstractList`, `AbstractSequentialList`

Method Summary
`void` | `add(int index, java.lang.Object element)` Inserts the specified element at the specified position in this List (optional operation).
`boolean` | `add(java.lang.Object o)` Appends the specified element to the end of this List (optional operation).
`boolean` | `addAll(Collection c)` Appends all of the elements in the specified Collection to the end of this this List, in the order that they are returned by the specified Collection's Iterator (optional operation).
`boolean` | `addAll(int index, Collection c)` Inserts all of the elements in the specified Collection into this List at the specified position (optional operation).
`void` | `clear()` Removes all of the elements from this List (optional operation).
`boolean` | `contains(java.lang.Object o)` Returns true if this List contains the specified element.
`boolean` | `containsAll(Collection c)` Returns true if this List contains all of the elements of the specified Collection.
`boolean` | `equals(java.lang.Object o)` Compares the specified Object with this List for equality.
`java.lang.Object` | `get(int index)` Returns the element at the specified position in this List.
`int` | `hashCode()` Returns the hash code value for this List.
`int` | `indexOf(java.lang.Object o)` Returns the index in this List of the first occurrence of the specified element, or -1 if the List does not contain this element.
`int` | `indexOf(java.lang.Object o, int index)` Returns the index in this List of the first occurrence of the specified element at or after the specified position, or -1 if the element is not found.
`boolean` | `isEmpty()` Returns true if this List contains no elements.
`Iterator` | `iterator()` Returns an Iterator over the elements in this List in proper sequence.
`int` | `lastIndexOf(java.lang.Object o)` Returns the index in this List of the last occurrence of the specified element, or -1 if the List does not contain this element.
`int` | `lastIndexOf(java.lang.Object o, int index)` Returns the index in this List of the last occurrence of the specified element at or before the specified position, or -1 if the List does not contain this element.
`ListIterator` | `listIterator()` Returns a ListIterator of the elements in this List (in proper sequence).
`ListIterator` | `listIterator(int index)` Returns a ListIterator of the elements in this List (in proper sequence), starting at the specified position in the List.
`java.lang.Object` | `remove(int index)` Removes the element at the specified position in this List (optional operation).
`boolean` | `remove(java.lang.Object o)` Removes the first occurrence of the specified element in this List (optional operation).
`boolean` | `removeAll(Collection c)` Removes from this List all of its elements that are contained in the specified Collection (optional operation).
`void` | `removeRange(int fromIndex, int toIndex)` Removes from this List all of the elements whose index is between fromIndex, inclusive and toIndex, exclusive (optional operation).
`boolean` | `retainAll(Collection c)` Retains only the elements in this List that are contained in the specified Collection (optional operation).
`java.lang.Object` | `set(int index, java.lang.Object element)` Replaces the element at the specified position in this List with the specified element (optional operation).
`int` | `size()` Returns the number of elements in this List.
`java.lang.Object[]` | `toArray()` Returns an array containing all of the elements in this List.

Method Detail

### size

    public int size()

  Returns the number of elements in this List.
  Specified by:
    `size` in interface `Collection`
  Since:
    JDK1.2

### isEmpty

    public boolean isEmpty()

  Returns true if this List contains no elements.
  Specified by:
    `isEmpty` in interface `Collection`
  Since:
    JDK1.2

### contains

    public boolean contains(java.lang.Object o)

  Returns true if this List contains the specified element. More formally, returns true if and only if this List contains at least one element `e` such that `(o==null ? e==null : o.equals(e))`.
  Specified by:
    `contains` in interface `Collection`
  Parameters:
    `o` - element whose presence in this List is to be tested.
  Since:
    JDK1.2

### iterator

    public Iterator iterator()

  Returns an Iterator over the elements in this List in proper sequence.
  Specified by:
    `iterator` in interface `Collection`
  Since:
    JDK1.2

### toArray

    public java.lang.Object[] toArray()

  Returns an array containing all of the elements in this List. Obeys the general contract of Collection.toArray.
  Specified by:
    `toArray` in interface `Collection`
  Since:
    JDK1.2
  See Also:
    `Arrays.toList(Object[])`

### add

    public boolean add(java.lang.Object o)

  Appends the specified element to the end of this List (optional operation).
  Specified by:
    `add` in interface `Collection`
  Parameters:
    `o` - element to be appended to this List.
  Returns:
    true (as per the general contract of Collection.add).
  Throws:
    `UnsupportedOperationException` - add is not supported by this Set.
    `java.lang.ClassCastException` - class of the specified element prevents it from being added to this Set.
    `java.lang.IllegalArgumentException` - some aspect of this element prevents it from being added to this Collection.
  Since:
    JDK1.2

### remove

    public boolean remove(java.lang.Object o)

  Removes the first occurrence of the specified element in this List (optional operation). If the List does not contain the element, it is unchanged. More formally, removes the element with the lowest index i such that `(o==null ? get(i)==null : o.equals(get(i)))` (if such an element exists).
  Specified by:
    `remove` in interface `Collection`
  Parameters:
    `o` - element to be removed from this List, if present.
  Returns:
    true if the List contained the specified element.
  Throws:
    `UnsupportedOperationException` - remove is not supported by this List.
  Since:
    JDK1.2

### containsAll

    public boolean containsAll(Collection c)

  Returns true if this List contains all of the elements of the specified Collection.
  Specified by:
    `containsAll` in interface `Collection`
  Since:
    JDK1.2
  See Also:
    `contains(Object)`

### addAll

    public boolean addAll(Collection c)

  Appends all of the elements in the specified Collection to the end of this this List, in the order that they are returned by the specified Collection's Iterator (optional operation). The behavior of this operation is unspecified if the specified Collection is modified while the operation is in progress. (Note that this will occur if the specified Collection is this List, and it's nonempty.)
  Specified by:
    `addAll` in interface `Collection`
  Parameters:
    `c` - elements to be inserted into this Collection.
  Returns:
    true if this List changed as a result of the call.
  Throws:
    `UnsupportedOperationException` - addAll is not supported by this List.
    `java.lang.ClassCastException` - class of an element in the specified Collection prevents it from being added to this List.
    `java.lang.IllegalArgumentException` - some aspect of an element in the specified Collection prevents it from being added to this List.
  Since:
    JDK1.2
  See Also:
    `add(Object)`

### removeAll

    public boolean removeAll(Collection c)

  Removes from this List all of its elements that are contained in the specified Collection (optional operation).
  Specified by:
    `removeAll` in interface `Collection`
  Parameters:
    `c` - elements to be removed from this Collection.
  Returns:
    true if this List changed as a result of the call.
  Throws:
    `UnsupportedOperationException` - removeAll is not supported by this List.
  Since:
    JDK1.2
  See Also:
    `remove(Object)`, `contains(Object)`

### retainAll

    public boolean retainAll(Collection c)

  Retains only the elements in this List that are contained in the specified Collection (optional operation). In other words, removes from this List all of its elements that are not contained in the specified Collection.
  Specified by:
    `retainAll` in interface `Collection`
  Parameters:
    `c` - elements to be retained in this Collection.
  Returns:
    true if this List changed as a result of the call.
  Throws:
    `UnsupportedOperationException` - retainAll is not supported by this List.
  Since:
    JDK1.2
  See Also:
    `remove(Object)`, `contains(Object)`

### clear

    public void clear()

  Removes all of the elements from this List (optional operation). The List will be empty after this call returns (unless it throws an exception).
  Specified by:
    `clear` in interface `Collection`
  Throws:
    `UnsupportedOperationException` - clear is not supported by this List.
  Since:
    JDK1.2

### equals

    public boolean equals(java.lang.Object o)

  Compares the specified Object with this List for equality. Returns true if and only if the specified Object is also a List, both Lists have the same size, and all corresponding pairs of elements in the two Lists are equal. (Two elements `e1` and `e2` are equal if `(e1==null ? e2==null : e1.equals(e2))`.) In other words, two Lists are defined to be equal if they contain the same elements in the same order.
  Specified by:
    `equals` in interface `Collection`
  Parameters:
    `o` - the Object to be compared for equality with this List.
  Returns:
    true if the specified Object is equal to this List.
  Since:
    JDK1.2

### hashCode

    public int hashCode()

  Returns the hash code value for this List. The hash code of a List is defined to be the result of the following calculation:

        hashCode = 0;
        Iterator i = list.iterator();
        while (i.hasNext()) {
            Object obj = i.next();
            hashCode = 31*hashCode + (obj==null ? 0 : obj.hashCode());
        }

  This ensures that `list1.equals(list2)` implies that `list1.hashCode()==list2.hashCode()` for any two Lists, `list1` and `list2`, as required by the general contract of Object.hashCode.
  Specified by:
    `hashCode` in interface `Collection`
  Since:
    JDK1.2
  See Also:
    `Object.hashCode()`, `Object.equals(Object)`, `Set.equals(Object)`

### get

    public java.lang.Object get(int index)

  Returns the element at the specified position in this List.
  Parameters:
    `index` - index of element to return.
  Throws:
    `java.lang.ArrayIndexOutOfBoundsException` - index is out of range (index < 0 || index >= size()).
  Since:
    JDK1.2

### set

    public java.lang.Object set(int index,
                                java.lang.Object element)

  Replaces the element at the specified position in this List with the specified element (optional operation).
  Parameters:
    `index` - index of element to replace.
    `element` - element to be stored at the specified position.
  Returns:
    the element previously at the specified position.
  Throws:
    `UnsupportedOperationException` - set is not supported by this List.
    `java.lang.ClassCastException` - class of the specified element prevents it from being added to this List.
    `java.lang.IllegalArgumentException` - some aspect of the specified element prevents it from being added to this List.
    `java.lang.ArrayIndexOutOfBoundsException` - index out of range (index < 0 || index >= size()).
  Since:
    JDK1.2

### add

    public void add(int index,
                    java.lang.Object element)

  Inserts the specified element at the specified position in this List (optional operation). Shifts the element currently at that position (if any) and any subsequent elements to the right (adds one to their indices).
  Parameters:
    `index` - index at which the specified element is to be inserted.
    `element` - element to be inserted.
  Throws:
    `UnsupportedOperationException` - add is not supported by this List.
    `java.lang.ClassCastException` - class of the specified element prevents it from being added to this List.
    `java.lang.IllegalArgumentException` - some aspect of the specified element prevents it from being added to this List.
    `java.lang.ArrayIndexOutOfBoundsException` - index is out of range (index < 0 || index > size()).
  Since:
    JDK1.2

### remove

    public java.lang.Object remove(int index)

  Removes the element at the specified position in this List (optional operation). Shifts any subsequent elements to the left (subtracts one from their indices). Returns the element that was removed from the List.
  Parameters:
    `index` - the index of the element to removed.
  Returns:
    the element previously at the specified position.
  Throws:
    `UnsupportedOperationException` - remove is not supported by this List.
    `java.lang.ArrayIndexOutOfBoundsException` - index out of range (index < 0 || index >= size()).
  Since:
    JDK1.2

### indexOf

    public int indexOf(java.lang.Object o)

  Returns the index in this List of the first occurrence of the specified element, or -1 if the List does not contain this element. More formally, returns the lowest index i such that `(o==null ? get(i)==null : o.equals(get(i)))`, or -1 if there is no such index.
  Parameters:
    `o` - element to search for.
  Since:
    JDK1.2

### indexOf

    public int indexOf(java.lang.Object o,
                       int index)

  Returns the index in this List of the first occurrence of the specified element at or after the specified position, or -1 if the element is not found. More formally, returns the lowest index i >= index such that `(o==null ? get(i)==null : o.equals(get(i)))`, or -1 if there is no such index.
  Parameters:
    `o` - element to search for.
    `index` - initial position to search for the specified element.
  Throws:
    `java.lang.ArrayIndexOutOfBoundsException` - index out of range (index < 0 || index >= size()).
  Since:
    JDK1.2

### lastIndexOf

    public int lastIndexOf(java.lang.Object o)

  Returns the index in this List of the last occurrence of the specified element, or -1 if the List does not contain this element. More formally, returns the highest index i such that `(o==null ? get(i)==null : o.equals(get(i)))`, or -1 if there is no such index.
  Parameters:
    `o` - element to search for.
  Since:
    JDK1.2

### lastIndexOf

    public int lastIndexOf(java.lang.Object o,
                           int index)

  Returns the index in this List of the last occurrence of the specified element at or before the specified position, or -1 if the List does not contain this element. More formally, returns the highest index i <= index such that `(o==null ? get(i)==null : o.equals(get(i)))`, or -1 if there is no such index.
  Parameters:
    `o` - element to search for.
    `index` - initial position to search for the specified element.
  Throws:
    `java.lang.ArrayIndexOutOfBoundsException` - index out of range (index < 0 || index >= size()).
  Since:
    JDK1.2

### removeRange

    public void removeRange(int fromIndex,
                            int toIndex)

  Removes from this List all of the elements whose index is between fromIndex, inclusive and toIndex, exclusive (optional operation). Shifts any succeeding elements to the left (reduces their index). This call shortens the List by (toIndex - fromIndex) elements. (If toIndex==fromIndex, this operation has no effect.)
  Parameters:
    `fromIndex` - index of first element to be removed.
    `toIndex` - index after last element to be removed.
  Throws:
    `UnsupportedOperationException` - removeRange is not supported by this List.
    `java.lang.ArrayIndexOutOfBoundsException` - fromIndex or toIndex out of range (fromIndex < 0 || fromIndex >= size() || toIndex > size() || toIndex < fromIndex).
  Since:
    JDK1.2

### addAll

    public boolean addAll(int index,
                          Collection c)

  Inserts all of the elements in the specified Collection into this List at the specified position (optional operation). Shifts the element currently at that position (if any) and any subsequent elements to the right (increases their indices). The new elements will appear in the List in the order that they are returned by the specified Collection's iterator. The behavior of this operation is unspecified if the specified Collection is modified while the operation is in progress. (Note that this will occur if the specified Collection is this List, and it's nonempty.)
  Parameters:
    `index` - index at which to insert first element from the specified Collection.
    `c` - elements to be inserted into this List.
  Returns:
    true if this List changed as a result of the call.
  Throws:
    `UnsupportedOperationException` - addAll is not supported by this List.
    `java.lang.ClassCastException` - class of one of elements of the specified Collection prevents it from being added to this List.
    `java.lang.IllegalArgumentException` - some aspect of one of elements of the specified Collection prevents it from being added to this List.
    `java.lang.ArrayIndexOutOfBoundsException` - index out of range (index < 0 || index > size()).
  Since:
    JDK1.2

### listIterator

    public ListIterator listIterator()

  Returns a ListIterator of the elements in this List (in proper sequence).
  Since:
    JDK1.2

### listIterator

    public ListIterator listIterator(int index)

  Returns a ListIterator of the elements in this List (in proper sequence), starting at the specified position in the List. The specified index indicates the first element that would be returned by an initial call to nextElement. An initial call to previousElement would return the element with the specified index minus one.
  Parameters:
    `index` - index of first element to be returned from the ListIterator (by a call to getNext).
  Throws:
    `java.lang.ArrayIndexOutOfBoundsException` - index is out of range (index < 0 || index > size()).
  Since:
    JDK1.2

Overview | Package | Class | Tree | Deprecated | Index | Help
| Oracle Application Development Framework Model and Business Components Java API Reference 10g Release 3 (10.1.3) B16005-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1997, 2005, Oracle. All rights reserved.